// Copyright (c) 2000 by Hiroaki YAMAZAKI, all rights reserved.
// You may use, copy, modify, distirbute this program under the
// conditions of GNU General Public License.
//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop
#include <shellapi.h>

#include "DnDWnd.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
	: TForm(Owner)
{
}
//---------------------------------------------------------------------------

void __fastcall TForm1::FormCreate(TObject *Sender)
{
	::DragAcceptFiles(Form1->Handle, TRUE);
	if (ParamCount() > 0) {
		filename = ParamStr(1);
		Memo1->Lines->LoadFromFile(filename);
	}
	dirty = false;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::OnFileDrop(TWMDropFiles &msg)
{
	char buff[512];
	const int nDropped =   DragQueryFile((HDROP)msg.Drop, 0xFFFFFFFF, NULL, 0);
	dirty = nDropped > 0;
	for (int i = 0; i < nDropped; ++i) {
		DragQueryFile((HDROP)msg.Drop, i, buff, 511);
		Memo1->Lines->Append(buff);
	}
	DragFinish((HDROP)msg.Drop);
	msg.Result = 0;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::saveFile()
{
	if (!dirty)
		return; // No need to save
	if (filename.IsEmpty()) {
		if (!SaveDialog->Execute())
			return;
		filename = SaveDialog->FileName;
	}
	Memo1->Lines->SaveToFile(filename);
	dirty = false;
}

//---------------------------------------------------------------------------

void __fastcall TForm1::btnOKClick(TObject *Sender)
{
	saveFile();
	Close();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::btnExitClick(TObject *Sender)
{
	if (dirty) {
		bool canClose = true;
		FormCloseQuery(Sender, canClose);
		if (!canClose) return;
	}
	if (!dirty)
		Close();
}
//---------------------------------------------------------------------------


void __fastcall TForm1::FormCloseQuery(TObject *Sender, bool &CanClose)
{
	if (dirty &&::MessageBox(Form1->Handle,
			Form1->sQueryAbandon->Caption.c_str(), Form1->Caption.c_str(),
			MB_OKCANCEL|MB_ICONEXCLAMATION) == IDCANCEL) {
		CanClose = false;
	} else {
		// OK. Abandon edit.
		dirty = false;
	}
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Memo1Change(TObject *Sender)
{
	dirty = true;
}
//---------------------------------------------------------------------------

